SystemOrganization addCategory: #'PLP-TP3'!

TestCase subclass: #InternacionalizadorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!InternacionalizadorTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 23:59'!
testRenameAMethodWithANameThatExists
	"Al renombrar un metodo con un nombre que ya existe deberia explotar"
	|in newSelector oldSelector|
	newSelector :=('initializeWith',':') asSymbol .
	oldSelector :=('transformar',':') asSymbol .
	in := Internacionalizador new.
	self should: [in renombrar: oldSelector por: newSelector] raise: Error.
	! !

!InternacionalizadorTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 23:59'!
testRenameANonExistMethod
	"Al renombrar un metodo que no existe deberia explotar"
	|in newSelector oldSelector|
	newSelector :=('transform',':') asSymbol .
	oldSelector :=('metodoNoExistis',':') asSymbol .
	in := Internacionalizador new.
	self should: [in renombrar: oldSelector por: newSelector] raise: Error.
	! !

!InternacionalizadorTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/14/2013 00:01'!
testRenameMethod
	
	"Usarlo bajo su propia responsabilidad (recargar imagen para asegurarse que la casa esta en orden luego de usar)"
	|in newSelector oldSelector|
	newSelector :=('transform',':') asSymbol .
	oldSelector :=('transformar',':') asSymbol .
	in := Internacionalizador new.
	in renombrar: oldSelector por: newSelector.

	! !

TestCase subclass: #TransformadorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'KevinKujawski 11/13/2013 01:25'!
testTransBloque

	| trans5 unBloque unaColeccionOrdenada |
	trans5 := self transformador5 .
	unaColeccionOrdenada := OrderedCollection new.
	unBloque := [ unaColeccionOrdenada add: 0 ].
	
	(trans5 transformar: unBloque) value.
	self assert: ( unaColeccionOrdenada size = 3 ).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'KevinKujawski 11/13/2013 01:25'!
testTransCaracter

	| trans2 trans3 |
	trans2 := self transformador2 .
	trans3 := self transformador3 .
	
	self assert: ( (trans2 transformar: 'patoloco') = 'pbtoloco' ).
	self assert: ( (trans2 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans3 transformar: 'elosodebimbo') = 'elosodeaimao' ).
	self assert: ( (trans3 transformar: 'patoloco') = 'patoloco' ).
! !

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'KevinKujawski 11/13/2013 01:25'!
testTransCondicion

	| trans8 trans9 
	unStringImpar otroStringImpar unStringPar otroStringPar 
	unBloquePar unBloqueImpar unaColeccionOrdenada unNuevoBloque |
	
	trans8 := self transformador8 .
	trans9 := self transformador9 .
	
	unStringImpar := 'bab'.
	unStringPar := 'aa'.
	otroStringImpar := 'aaa'.
	otroStringPar := 'bb'.
	
	self assert: ( (trans8 transformar: unStringPar) = 'bb' ).
	self assert: ( (trans8 transformar: unStringImpar) = 'aaa' ).
	self assert: ( (trans8 transformar: otroStringPar) = otroStringPar ).
	self assert: ( (trans8 transformar: otroStringImpar ) = otroStringImpar ).
	
	unaColeccionOrdenada := OrderedCollection new.
	unBloquePar := [ unaColeccionOrdenada add:0. ^4 ].
	unBloqueImpar := [ unaColeccionOrdenada add:0. ^3 ].
	
	unNuevoBloque := trans9 transformar: unBloquePar.
	unaColeccionOrdenada := OrderedCollection new.
	unNuevoBloque value.
	self assert: (unaColeccionOrdenada size = 3).
	
	unNuevoBloque := trans9 transformar: unBloqueImpar.
	unaColeccionOrdenada := OrderedCollection new.
	unNuevoBloque value.
	self assert: (unaColeccionOrdenada size = 1).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'KevinKujawski 11/13/2013 01:25'!
testTransIdentidad

| unTransformadorIdentidad |
unTransformadorIdentidad := self transformador1 .
self assert: ( unTransformadorIdentidad transformar: self == self ).! !

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'KevinKujawski 11/13/2013 01:25'!
testTransSecuencial

	| trans6 trans7 |
	trans6 := self transformador6 .
	trans7 := self transformador7 .
	
	self assert: ( (trans6 transformar: 'patoloco') = 'patoloco' ).
	self assert: ( (trans6 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans6 transformar: 'elosodebimbo') = 'elosodeaimao' ).
	self assert: ( (trans7 transformar: 'patoloco') = 'pbtoloco' ).
	self assert: ( (trans7 transformar: 'monoloco') = 'monoloco' ).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'KevinKujawski 11/13/2013 01:25'!
testTransSubstring

	| trans4 |
	trans4 := self transformador4 .
	
	self assert: ( (trans4 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans4 transformar: 'buu') = 'md' ).
	self assert: ( (trans4 transformar: 'monobuuloco') = 'monomdloco' ).! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'MartinCarreiro 11/11/2013 16:07'!
transformador1
	"Debe retornar el transformador especificado en el enunciado"
	^TransIdentidad new.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'MartinCarreiro 11/11/2013 16:13'!
transformador2
	"Debe retornar el transformador especificado en el enunciado"
	^TransCaracter newWith:'a' and:'b'! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'MartinCarreiro 11/11/2013 16:13'!
transformador3
	"Debe retornar el transformador especificado en el enunciado"
	^TransCaracter newWith:'b' and:'a'! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'KevinKujawski 11/14/2013 00:14'!
transformador4
	"Debe retornar el transformador especificado en el enunciado"
	^TransCaracter newWith:'buu' and:'md'! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'MartinCarreiro 11/11/2013 16:54'!
transformador5
	"Debe retornar el transformador especificado en el enunciado"
	^TransBloque newWith:3.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'KevinKujawski 11/14/2013 00:17'!
transformador6
	"Debe retornar el transformador especificado en el enunciado"
	^TransSecuencial newWith:(self transformador2) and:(self transformador3) ! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'KevinKujawski 11/14/2013 00:17'!
transformador7
	"Debe retornar el transformador especificado en el enunciado"
	^TransSecuencial newWith:(self transformador6) and:(self transformador2) ! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'KevinKujawski 11/14/2013 00:32'!
transformador8
	
	"Debe retornar el transformador especificado en el enunciado"
	^TransCondicion newWith:  [:aString | aString size even ] going: (self transformador2) or: (self transformador3)! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'KevinKujawski 11/14/2013 00:49'!
transformador9
	"Debe retornar el transformador especificado en el enunciad o"
	^TransCondicion newWith:  [:aBlock | aBlock value even ] going: (self transformador5) or: (self transformador1)! !

Object subclass: #Internacionalizador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!Internacionalizador class methodsFor: 'as yet unclassified' stamp: 'ManuelGimenez 10/29/2013 23:03'!
arreglar
	"Debe modificar la implementacion para reflejar complacer el ultimo capricho del arquitecto"
	self notYetImplemented .! !

!Internacionalizador methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 23:19'!
renombrar: selectorOriginal por: nuevoSelector
 | refactoring |
	refactoring := RBRenameMethodRefactoring 
		renameMethod: selectorOriginal 
		in: Transformador
		to: nuevoSelector
		permutation: (1 to: 1).
		refactoring execute .! !

Object subclass: #Transformador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

Transformador subclass: #TransBloque
	instanceVariableNames: 'amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransBloque class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 16:52'!
newWith:amount

	|instance|
	
	instance := self new.
	^instance initializeWith:amount.! !

!TransBloque methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 16:53'!
initializeWith:newAmount

	amount := newAmount.! !

!TransBloque methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 01:25'!
transformar:unBloque

	^ [ amount timesRepeat: unBloque]! !

Transformador subclass: #TransCompuesto
	instanceVariableNames: 't1 t2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

TransCompuesto subclass: #TransAleatorio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransAleatorio methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 01:25'!
transformar: unObjeto
	|listInstanceVariables aRandomTransformer|
	
	listInstanceVariables := (LinkedList new add:t1 )add: t2.
	aRandomTransformer := listInstanceVariables atRandom.
	
   ^ aRandomTransformer transformar: unObjeto.! !

!TransCompuesto class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 16:56'!
newWith: t1 and: t2 
	
	|instance|
	
	instance := self new.
	instance initializeWith: t1 and: t2.! !

!TransCompuesto methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 16:57'!
initializeWith: newt1 and: newt2

	t1 := newt1.
	t2 := newt2.	! !

TransCompuesto subclass: #TransCondicion
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransCondicion class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/12/2013 00:55'!
newWith:aCondition going:t1 or:t2 
	
	|instance|
	
	instance := self new.
	^instance initializeWith:aCondition goint:t1 or:t2. ! !

!TransCondicion methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/12/2013 00:57'!
initializeWith:aCondition goint:newt1 or:newt2

	condition := aCondition.
	t1 := newt1.
	t2 := newt2.! !

!TransCondicion methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 01:25'!
transformar: unObjeto
	
	(condition value) ifTrue: 
		[^ t1 transformar: unObjeto ]
	ifFalse:
		[^ t2 transformar: unObjeto ]
! !

TransCompuesto subclass: #TransSecuencial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransSecuencial methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 01:25'!
transformar: unObjeto

   ^ t2 transformar: (t1 transformar: unObjeto).! !

Transformador subclass: #TransIdentidad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransIdentidad methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 01:25'!
transformar: unObjeto
	^unObjeto.! !

Transformador subclass: #TransString
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

TransString subclass: #TransCaracter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransString class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 16:12'!
newWith:from and:to 

	|instance|
	
	instance := self new.
	^instance initializeWith:from and:to.! !

!TransString methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 16:46'!
initializeWith:fromNew and:toNew
	
	from := fromNew.
	to := toNew.
	! !

!TransString methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 01:25'!
transformar:unString 

	^ unString copyWithRegex: from matchesReplacedWith: to.

	
	! !

TransString subclass: #TransSubstring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!Transformador methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 03:50'!
comoListaEquivalente

	self notYetImplemented .! !

!Transformador methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 11/13/2013 01:25'!
transformar: unObjeto
	self subclassResponsibility  .! !
